/*
 * nextEdge.c - Bring in next edge when using extended input method, OBSOLETE.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved worldwide.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

#include <cluster.h>
#include <matchSet.h>

#define CharBufferSize		256

#ifdef	IncludeExcludeFiles

/*****************
 * Generate match set with: "cSet -c counter i match r nodeId i none v"
 */

typedef struct nextEdgeExtern	NextEdgeExternType;
struct nextEdgeExtern
{
	matchSetType	includeSetBuffer;
	matchSetType*	includeSet;
	matchSetType	excludeSetBuffer;
	matchSetType*	excludeSet;
};

NextEdgeExternType	nextEdgeExternBuffer = {
	{},
	&nextEdgeExternBuffer.includeSetBuffer,
	{},
	&nextEdgeExternBuffer.excludeSetBuffer
};

NextEdgeExternType*	nextEdgeExtern = &nextEdgeExternBuffer;

void	fileToMatch(matchSetType* matchSet, char* fileName);

int
nextEdge(edgeType* edge)
{
	int	needLink = 1;	/* Dummy flag since break is used. */
	while (needLink)
	{
		if (readEntrezBin(edge) == 0)
		{
			return(0);
		}
		if ((matchSearch(nextEdgeExtern->excludeSet, edge->a) == 0 &&
		    matchSearch(nextEdgeExtern->excludeSet, edge->b) == 0) &&
		    (matchSearch(nextEdgeExtern->includeSet, edge->a) != 0
#ifdef IncludeAnd
		    &&
#else
		    ||
#endif /* IncludeAnd */
		    matchSearch(nextEdgeExtern->includeSet, edge->b) != 0))
		{
			break;
		}
	}
	return(1);
}

void
nextEdgeInit(char* includeFileName, char* excludeFileName)
{
	fileToMatch(nextEdgeExtern->includeSet, includeFileName);
	fileToMatch(nextEdgeExtern->excludeSet, excludeFileName);
}

void
fileToMatch(matchSetType* matchSet, char* fileName)
{
	FILE*		inputFp;
	nodeIdType	nodeId;
	char		found;
	char		input[CharBufferSize];
	char		errorMessage[CharBufferSize];

	inputFp = fopen(fileName, "r");
	if (inputFp == 0)
	{
		strcpy(errorMessage, "fileToMatch: open error on file ");
		strcat(errorMessage, fileName);
		strcat(errorMessage, ".\n");
		stop(errorMessage);
	}
	matchInit(matchSet);
	input[sizeof(input) - 1] = '\0';
	while(fgets(input, sizeof(input), inputFp) != 0)
	{
                /*****************
                 * Make sure we did not overflow the input buffer and convert
                 * the trailing newline to a null.
                 */
		if (input[sizeof(input) - 1] != '\0')
		{
			stop("nextEdgeInit: input buffer overflow");
		}
                input[strlen(input) - 1] = '\0';

		/*****************
		 * Convert from ascii to binary.
		 */
		nodeId = nodeIdStrtob(input, 0);

		/*****************
		 * Search or insert the nodes, don't want duplicates.
		 */
		(void) matchSInsert(matchSet, nodeId, &found);
	}
	fclose(inputFp);
}

#endif /* IncludeExcludeFiles */
