/*
 * singleLinkage.c - Linkage routine optimized for single linkage.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved worldwide.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

/*****************
 * Got to include the actual variables in some file.  Probably should have
 * used cluster.c/main for this but not sure how I am going to support all
 * the various types at the moment.
 */
#define cTypeVariables
#define cSetVariables
#define clusterVariables
#include <cluster.h>

void	singleLinkage(void)
{
	nodeSetType	nodeSetBuf, *nodeSet = &nodeSetBuf;
	nodeMemberType	*m;
	edgeType	edgeBuf, *edge = &edgeBuf;
	nodeType	*a, *b;
	char		found;

	/*****************
	 * Process all the edges.
	 */
	nodeInit(nodeSet);
	while(nextEdge(edge)) {

		/*****************
		 * Make sure this value exceeds the cutoff.
		 */
		if (edge->score < clusterExtern->minimumScore)
			continue;

		/*****************
		 * Search or insert the nodes.
		 */
		m = nodeSInsert(nodeSet, edge->a, &found);
		if (!found) {
			a = newNode();
			a->id = edge->a;
			m->value = (void *) a;
			
		}
		else {
			a = (nodeType *) m->value;
		}
		m = nodeSInsert(nodeSet, edge->b, &found);
		if (!found) {
			b = newNode();
			b->id = edge->b;
			m->value = (void *) b;
			
		}
		else {
			b = (nodeType *) m->value;
		}

		/*****************
		 * Merge the two nodes only if they aren't already merged.
		 */
		if (a->memberOf != b->memberOf) {
			merge(a->memberOf, b->memberOf, edge);
		}
	}
#if 0
	nodeDump(nodeSet);
#endif
	doDump();
}
