#!/bin/sh
#
# Make a binary distribution tar file of everything needed.

if [ -d bin ]; then
	echo bin directory already exists 1>&2
	exit 1
fi

test "$1" || { echo top_srcdir argument missing; exit 1; }
top_srcdir=$1

mkdir bin lib lib/pima man man/man1

binfiles="
cluster-1.0/cluster-pima
main/pima-mso
main/pima-pm
misc/extract-cluster-loci
misc/extract-records
misc/extract-root-pat
misc/print-cluster
misc/trim-root-num
print-pima/print-pima
scripts/make-cluster
scripts/make-pattern
scripts/pima
scripts/pima-gde
"

datafiles="
data/aaclass1.def
data/aaclass2.def
data/class1.mat
data/class2.mat
data/patgen.mat
tests/sample-family.fa
tests/sample-struct.fa
"

manpages="
doc/pima.1
doc/print-pima.1
"

for i in $binfiles; do
	ln -s ../../$i bin
done

if expr x$top_srcdir : x/ >/dev/null; then
    prefix=$top_srcdir
else
    prefix=../../$top_srcdir
fi

for i in $datafiles; do
	ln -s $prefix/$i lib/pima
done

for i in $manpages; do
	ln -s $prefix/$i man/man1
done

tar cvhf - bin/* lib/pima/* man/man1/*
