/*
 * crpIvvS.c - Method of C dynamic set library.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

/*****************
 * DO NOT EDIT this file.  This file was automatically generated by the
 * command "../../perl/cSetTran.pl ../../c/cSet/r.h ../../c/cSet/common.h" and any changes
 * should be made to the translation command itself or the source file that
 * was translated instead of directly to this file.
 */

#ifndef crpIvvSdefined
#define crpIvvSdefined
#include <cType.h>
#include <cSet.h>

#undef crpIvvScmp

typedef struct _crpIvvSmember	crpIvvSmember;
typedef struct _crpIvvSset	crpIvvSset;

/*
 * r.h - Header file for C dynamic set routines for red-black trees.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

struct _crpIvvSmember {
	void *		key;
	crpIvvSmember	*left;
	crpIvvSmember	*right;
	crpIvvSmember	*parent;
	char		black;
};

struct _crpIvvSset {
	crpIvvSmember	*root;
	crpIvvSmember	*nil;
#ifdef crpIvvSuserCmp
	int		(*cmp)();
#endif
};
/*
 * common.h - Common header file for all C dynamic set routines.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

/*****************
 * This file (the rest of this file) is ../../c/cSet/common.h which
 * has information that is common to all header files and still needs
 * to be translated.  If the code here doesn't need template translation
 * then it should be put in ../cSet.h
 */
#ifndef crpIvvSinit
void		crpIvvSinit(crpIvvSset *S);
#endif
#ifndef crpIvvSfinal
void		crpIvvSfinal(crpIvvSset *S);
#endif
#ifndef crpIvvSinsert
crpIvvSmember	*crpIvvSinsert(crpIvvSset *S, void * K);
#endif
#ifndef crpIvvSsearch
crpIvvSmember	*crpIvvSsearch(crpIvvSset *S, void * K);
#endif
#ifndef crpIvvSsInsert
crpIvvSmember	*crpIvvSsInsert(crpIvvSset *S, void * K, char *found);
#endif
#ifndef crpIvvSdelete
void		crpIvvSdelete(crpIvvSset *S, crpIvvSmember *P);
#endif
#ifndef crpIvvSsDelete
void		crpIvvSsDelete(crpIvvSset *S, void * K, char *found);
#endif
#ifndef crpIvvSfirst
crpIvvSmember 	*crpIvvSfirst(crpIvvSset *S);
#endif
#ifndef crpIvvSlast
crpIvvSmember	*crpIvvSlast(crpIvvSset *S);
#endif
#ifndef crpIvvSnext
crpIvvSmember	*crpIvvSnext(crpIvvSset *S, crpIvvSmember *P);
#endif
#ifndef crpIvvSprev
crpIvvSmember	*crpIvvSprev(crpIvvSset *S, crpIvvSmember *P);
#endif
#ifndef crpIvvSdumpMember
void		crpIvvSdumpMember(crpIvvSset *S, crpIvvSmember *P);
#endif
#ifndef crpIvvSdump
void		crpIvvSdump(crpIvvSset *S);
#endif
#endif /* crpIvvSdefined */
