/*
 * crsIspS.c - Method of C dynamic set library.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

/*****************
 * DO NOT EDIT this file.  This file was automatically generated by the
 * command "../../perl/cSetTran.pl ../../c/cSet/r.h ../../c/cSet/common.h" and any changes
 * should be made to the translation command itself or the source file that
 * was translated instead of directly to this file.
 */

#ifndef crsIspSdefined
#define crsIspSdefined
#include <cType.h>
#include <cSet.h>

#ifndef crsIspScmp
#define crsIspScmp(a, b)	strcmp(a, b)
#endif

typedef struct _crsIspSmember	crsIspSmember;
typedef struct _crsIspSset	crsIspSset;

/*
 * r.h - Header file for C dynamic set routines for red-black trees.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

struct _crsIspSmember {
	char *		key;
	void *		value;
	crsIspSmember	*left;
	crsIspSmember	*right;
	crsIspSmember	*parent;
	char		black;
};

struct _crsIspSset {
	crsIspSmember	*root;
	crsIspSmember	*nil;
#ifdef crsIspSuserCmp
	int		(*cmp)();
#endif
};
/*
 * common.h - Common header file for all C dynamic set routines.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

/*****************
 * This file (the rest of this file) is ../../c/cSet/common.h which
 * has information that is common to all header files and still needs
 * to be translated.  If the code here doesn't need template translation
 * then it should be put in ../cSet.h
 */
#ifndef crsIspSinit
void		crsIspSinit(crsIspSset *S);
#endif
#ifndef crsIspSfinal
void		crsIspSfinal(crsIspSset *S);
#endif
#ifndef crsIspSinsert
crsIspSmember	*crsIspSinsert(crsIspSset *S, char * K);
#endif
#ifndef crsIspSsearch
crsIspSmember	*crsIspSsearch(crsIspSset *S, char * K);
#endif
#ifndef crsIspSsInsert
crsIspSmember	*crsIspSsInsert(crsIspSset *S, char * K, char *found);
#endif
#ifndef crsIspSdelete
void		crsIspSdelete(crsIspSset *S, crsIspSmember *P);
#endif
#ifndef crsIspSsDelete
void		crsIspSsDelete(crsIspSset *S, char * K, char *found);
#endif
#ifndef crsIspSfirst
crsIspSmember 	*crsIspSfirst(crsIspSset *S);
#endif
#ifndef crsIspSlast
crsIspSmember	*crsIspSlast(crsIspSset *S);
#endif
#ifndef crsIspSnext
crsIspSmember	*crsIspSnext(crsIspSset *S, crsIspSmember *P);
#endif
#ifndef crsIspSprev
crsIspSmember	*crsIspSprev(crsIspSset *S, crsIspSmember *P);
#endif
#ifndef crsIspSdumpMember
void		crsIspSdumpMember(crsIspSset *S, crsIspSmember *P);
#endif
#ifndef crsIspSdump
void		crsIspSdump(crsIspSset *S);
#endif
#endif /* crsIspSdefined */
