/*
 * crsIsvS.c - Method of C dynamic set library.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

/*****************
 * DO NOT EDIT this file.  This file was automatically generated by the
 * command "../../perl/cSetTran.pl ../../c/cSet/r.h ../../c/cSet/common.h" and any changes
 * should be made to the translation command itself or the source file that
 * was translated instead of directly to this file.
 */

#ifndef crsIsvSdefined
#define crsIsvSdefined
#include <cType.h>
#include <cSet.h>

#ifndef crsIsvScmp
#define crsIsvScmp(a, b)	strcmp(a, b)
#endif

typedef struct _crsIsvSmember	crsIsvSmember;
typedef struct _crsIsvSset	crsIsvSset;

/*
 * r.h - Header file for C dynamic set routines for red-black trees.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

struct _crsIsvSmember {
	char *		key;
	crsIsvSmember	*left;
	crsIsvSmember	*right;
	crsIsvSmember	*parent;
	char		black;
};

struct _crsIsvSset {
	crsIsvSmember	*root;
	crsIsvSmember	*nil;
#ifdef crsIsvSuserCmp
	int		(*cmp)();
#endif
};
/*
 * common.h - Common header file for all C dynamic set routines.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

/*****************
 * This file (the rest of this file) is ../../c/cSet/common.h which
 * has information that is common to all header files and still needs
 * to be translated.  If the code here doesn't need template translation
 * then it should be put in ../cSet.h
 */
#ifndef crsIsvSinit
void		crsIsvSinit(crsIsvSset *S);
#endif
#ifndef crsIsvSfinal
void		crsIsvSfinal(crsIsvSset *S);
#endif
#ifndef crsIsvSinsert
crsIsvSmember	*crsIsvSinsert(crsIsvSset *S, char * K);
#endif
#ifndef crsIsvSsearch
crsIsvSmember	*crsIsvSsearch(crsIsvSset *S, char * K);
#endif
#ifndef crsIsvSsInsert
crsIsvSmember	*crsIsvSsInsert(crsIsvSset *S, char * K, char *found);
#endif
#ifndef crsIsvSdelete
void		crsIsvSdelete(crsIsvSset *S, crsIsvSmember *P);
#endif
#ifndef crsIsvSsDelete
void		crsIsvSsDelete(crsIsvSset *S, char * K, char *found);
#endif
#ifndef crsIsvSfirst
crsIsvSmember 	*crsIsvSfirst(crsIsvSset *S);
#endif
#ifndef crsIsvSlast
crsIsvSmember	*crsIsvSlast(crsIsvSset *S);
#endif
#ifndef crsIsvSnext
crsIsvSmember	*crsIsvSnext(crsIsvSset *S, crsIsvSmember *P);
#endif
#ifndef crsIsvSprev
crsIsvSmember	*crsIsvSprev(crsIsvSset *S, crsIsvSmember *P);
#endif
#ifndef crsIsvSdumpMember
void		crsIsvSdumpMember(crsIsvSset *S, crsIsvSmember *P);
#endif
#ifndef crsIsvSdump
void		crsIsvSdump(crsIsvSset *S);
#endif
#endif /* crsIsvSdefined */
