/*
 * cType.c - General support routines for C type library.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

#include <stdio.h>
#include <cType.h>

/*****************
 * Just some memory allocation routines.  Allow these functions to be
 * redefined since they call exit and that might not be acceptable.
 * It is assumed that they will never return a null pointer though,
 * so if you replace them make sure something meaningful is always returned.
 */

char		*_cTypeMalloc(unsigned size);
char		*_cTypeRealloc(char *buf, unsigned size);
int		_cTypeExit(int status);

char	*_cTypeMalloc(unsigned size)
{
	char	*p;

	p = malloc(size);
	if (! p) {
		fprintf(stderr, "_cTypeMalloc: ERROR allocating %d bytes.\n",
			size);
		(*cTypeExternP->abort)(1);
	}
	return(p);
}

char	*_cTypeRealloc(char *buf, unsigned size)
{
	char	*p;

	p = realloc(buf, size);
	if (! p) {
		fprintf(stderr,
			"_cTypeRealloc: ERROR reallocating %d bytes.\n",
			size);
		cTypeExternP->abort(1);
	}
	return(p);
}

/***** A macro should suffice.
void	_cTypeFree(char *buf)
{
	free(buf);
}
 ****/

int	_cTypeExit(int status)
{
	fprintf(stderr, "_cTypeExit: cType abort routine exit\n");
	exit(status);
}
