/*************************************************************************/
#include <pima_lib.h>
#ifdef UWP
#include "octal.h"
#endif

#define LOCAL_LOCAL
#if 0
#define MIN_LOCAL_SCORE 22550
#define MIN_QUAD_WIDTH 15
#endif


#ifdef LOCAL_LOCAL
void link_trace_backs(DIRECTION_VALUES **trace_back, int LOi, int LOj, int UPi, int UPj, int V_start, int H_start);
#endif

void
paths(int *Vpoint, int *Hpoint, int **path1, int *p_l1, int **path2,
int *p_l2, int nV, int nH, int (*S)[MAXAR], int *start,
long int *coeff2A, int *p_Hmax, int *coeffg1V, int *coeffg2V,
int *coeffg1H, int *coeffg2H, int coeffg1, int coeff_s, char *Vseq,
char *Hseq, int mso, int *p_l1a
#ifdef UWP
, int  *Vweight, *Hweight
#endif
#ifdef LOCAL_LOCAL
, int UPi, int UPj, int LOi, int LOj, int *p_LOLOi, int *p_LOLOj,
  DIRECTION_VALUES **trace_back, int V_start, int V_end, int H_start, int H_end, int min_local_score, int min_local_width
#endif
)
{
	int ROW = 0,
	COLUMN = 1,
	i,
	j,
	l1,
	l2,
	West,
	NWest,
	North;
	int LWj,
	*LNi,
	**H,
	H_LWj,
	*H_LNi,
	Hmax;
	int *H_swap;

	register int H_1_j,
	coeffg1V_i;
	int coeffg1H_LWj,
	*coeffg1V_LNi;
	int LWj_g,
	*LNi_g,
	H_LWj_g,
	*H_LNi_g;
	int West_g,
	North_g,
	dist_west,
	dist_north;
	int l1a;

#ifdef UWP
	int score,
	card();
	long Sprofile;

#endif

#ifndef LOCAL_LOCAL
	DIRECTION_VALUES **trace_back;
	int V_start,
	V_end,
	H_start,
	H_end;
#endif

#ifdef LOCAL_LOCAL
	int LOLOi,
	LOLOj;
	int k;
	char *tmp_Vseq,
	*tmp_Hseq;
	int end_i, end_j, start_i, start_j;
	int UPi_last, UPj_last, LOi_last, LOj_last;
	int LOLOi_last, LOLOj_last;
	int V_start_last, V_end_last;
	int H_start_last, H_end_last;
	int tmp_Hmax;
#endif

#ifdef LOCAL_LOCAL
	LOLOi = LOLOj = 0;
	UPi_last = UPi;
	UPj_last = UPj;
	LOi_last = LOi;
	LOj_last = LOj;
	LOLOi_last = *p_LOLOi;
	LOLOj_last = *p_LOLOj;
	V_start_last = V_start;
	V_end_last = V_end;
	H_start_last = H_start;
	H_end_last = H_end;
#endif
	l2 = 0;


	V_start = 1;
	while (Vseq[V_start] == '-')
		V_start++;
	V_end = nV;
	while (Vseq[V_end] == '-')
		V_end--;
	H_start = 1;
	while (Hseq[H_start] == '-')
		H_start++;
	H_end = nH;
	while (Hseq[H_end] == '-')
		H_end--;



#ifndef LOCAL_LOCAL
	if (mso == FALSE) {
		trace_back = (DIRECTION_VALUES **) calloc((unsigned) (V_end - V_start + 2),
		    sizeof(DIRECTION_VALUES *));
		check_calloc((int *) trace_back, "trace_back");

		for (i = 0; i <= V_end - V_start + 1; i++) {
			trace_back[i] = (DIRECTION_VALUES *) calloc((unsigned)
			    (H_end - H_start + 2),
			    sizeof(DIRECTION_VALUES));
			check_calloc((void *) trace_back[i], "trace_back[i]");
		}
	}
#endif

	LNi = (int *) calloc((unsigned) nH + 2, sizeof(int));

	check_calloc(LNi, "LNi");
	H = (int **) calloc((unsigned) 2, sizeof(int *));

	check_calloc((int *) H, "H");
	H[0] = (int *) calloc((unsigned) nH + 2, sizeof(int));

	check_calloc(H[0], "H[0]");
	H[1] = (int *) calloc((unsigned) nH + 2, sizeof(int));

	check_calloc(H[1], "H[1]");
	H_LNi = (int *) calloc((unsigned) nH + 2, sizeof(int));

	check_calloc(H_LNi, "H_LNi");

	H_LNi_g = (int *) calloc((unsigned) nH + 2, sizeof(int));

	check_calloc(H_LNi_g, "H_LNi_g");
	LNi_g = (int *) calloc((unsigned) nH + 2, sizeof(int));

	check_calloc(LNi_g, "LNi_g");
	coeffg1V_LNi = (int *) calloc((unsigned) nH + 2, sizeof(int));

	check_calloc(coeffg1V_LNi, "coeffg1V_LNi");

	Hmax = 0;
	start[ROW] = V_start;
	start[COLUMN] = H_start;

	for (j = 1; j <= nH; j++) {
		H_LNi[j] = 0;
		LNi[j] = 0;
		H_LNi_g[j] = 0;
		LNi_g[j] = 0;
		coeffg1V_LNi[j] = coeffg1;
	}

	for (i = V_start; i <= V_end; i++) {
		coeffg1V_i = coeffg1V[i];
		LWj = H_LWj = 0;
		LWj_g = H_LWj_g = 0;
		coeffg1H_LWj = coeffg1;

		for (j = H_start; j <= H_end; j++) {

			if ((coeffg1V_i < coeffg1) || (coeffg1H[j] < coeffg1)) {
				if (H_LWj > H_LWj_g) {
					LWj_g = LWj;
					H_LWj_g = H_LWj;
				}
				if (H_LNi[j] > H_LNi_g[j]) {
					LNi_g[j] = LNi[j];
					H_LNi_g[j] = H_LNi[j];
				}
				if (coeffg1H[j] < coeffg1) {
					H_LWj_g = H_LWj_g + coeff2A[1];
				}
				if (coeffg1V_i < coeffg1) {
					H_LNi_g[j] = H_LNi_g[j] + coeff2A[1];
				}
			}
			West = H_LWj - coeffg1H_LWj - coeff2A[j - LWj];
			West_g = H_LWj_g /* -1 */  - coeff2A[j - LWj_g];

			North = H_LNi[j] - coeffg1V_LNi[j] - coeff2A[i - LNi[j]];
			North_g = H_LNi_g[j] /* -1 */ -coeff2A[i - LNi_g[j]];

			if ((coeffg1V_i > coeffg1) || (coeffg1H[j] > coeffg1)) {
				West -= coeff_s;
				West_g -= coeff_s;

				North -= coeff_s;
				North_g -= coeff_s;
			}
			if (West >= West_g)
				dist_west = j - LWj;
			else {
				dist_west = j - LWj_g;
				West = West_g;
			}

			if (North >= North_g)
				dist_north = i - LNi[j];
			else {
				dist_north = i - LNi_g[j];
				North = North_g;
			}

#ifdef UWP
			Sprofile = (Vprofile[i] | Hprofile[j]);
			if ((Sprofile & octal[21]) != 0)
				score = 0;
				else
				score = ((int) (100.0 * 1 / card(20, Sprofile))) - 10;
			NWest = H[0][j - 1] + score;
#else
			NWest = H[0][j - 1] + S[Vpoint[i]][Hpoint[j]];
#endif
			H_1_j = H[1][j] = MAX(MAX(West, NWest), MAX(North, 0));
			if (mso == FALSE) {
				if (H_1_j > 0) {
					if (H_1_j == NWest) {

#ifdef LOCAL_LOCAL
						trace_back[i - V_start_last + 1][j - H_start_last + 1].direction = NWEST;
						trace_back[i - V_start_last + 1][j - H_start_last + 1].distance = 1;
					} else if (H_1_j == West) {
						trace_back[i - V_start_last + 1][j - H_start_last + 1].direction = WEST;
						trace_back[i - V_start_last + 1][j - H_start_last + 1].distance = dist_west;
					}
					else {
						trace_back[i - V_start_last + 1][j - H_start_last + 1].direction = NORTH;
						trace_back[i - V_start_last + 1][j - H_start_last + 1].distance = dist_north;
					}


#else

						trace_back[i - V_start + 1][j - H_start + 1].direction = NWEST;
						trace_back[i - V_start + 1][j - H_start + 1].distance = 1;
					} else if (H_1_j == West) {
						trace_back[i - V_start + 1][j - H_start + 1].direction = WEST;
						trace_back[i - V_start + 1][j - H_start + 1].distance = dist_west;
					}
					else {
						trace_back[i - V_start + 1][j - H_start + 1].direction = NORTH;
						trace_back[i - V_start + 1][j - H_start + 1].distance = dist_north;
					}
#endif

				}
			}
			if (H_1_j == NWest && H_1_j > 0) {

				if ((coeffg1V_i < coeffg1) || (coeffg1H[j] < coeffg1)) {
					if (H_1_j > West_g) {
						LWj_g = j;
						H_LWj_g = H_1_j;
					}
					if (H_1_j > North_g) {
						LNi_g[j] = i;
						H_LNi_g[j] = H_1_j;
					}
				}
				if ((coeffg1V_i == coeffg1) || (coeffg1H[j] == coeffg1)) {

					if (H_1_j > (H_LWj - coeff2A[j - LWj])) {
						LWj = j;
						H_LWj = H_1_j;
					}
					if (H_1_j > (H_LNi[j] - coeff2A[i - LNi[j]])) {
						LNi[j] = i;
						H_LNi[j] = H_1_j;
					}
				}
			}
			if (Hmax < H_1_j) {
				Hmax = H_1_j;
				start[ROW] = i;
				start[COLUMN] = j;
			}
		}
		/*      this loop can be substituted for the following bcopy  
			 * for (j = 1; j<= nH; j++)
			 * H[0][j]=H[1][j];
			 */

		/*
			 * This old bcopy routine was replaced once dynamic allocation
			 * was used.
			bcopy(&(H[1][1]), &(H[0][1]), sizeof(int) * nH);
			 */
		H_swap = H[0];
		H[0] = H[1];
		H[1] = H_swap;
	}

#ifdef LOCAL_LOCAL
/* printf("Starting trace-back, Hmax=%d\n", Hmax);  */

	i = start_i = end_i = start[ROW];
	j = start_j = end_j = start[COLUMN];
	l1 = 0;
	l1a = 0;

	if (mso == FALSE) {
		while ((trace_back[i - V_start_last + 1][j - H_start_last + 1].distance > 0) && (i >= V_start) && (j >= H_start)) {
		        l1++;
			end_i = i;
			end_j = j;
/* printf("i1=%d, j1=%d\n", i,j); */
			if (trace_back[i - V_start_last + 1][j - H_start_last + 1].direction == NWEST) {
				i = i - 1;
				j = j - 1;
				l1a++;
			}
			else if (trace_back[i - V_start_last + 1][j - H_start_last + 1].direction == WEST) {
				i = i;
				j = j - (int) trace_back[i - V_start_last + 1][j - H_start_last + 1].distance;
				l1a += (int) trace_back[i - V_start_last + 1][j - H_start_last + 1].distance;
			} else {
				i = i - (int) trace_back[i - V_start_last + 1][j - H_start_last + 1].distance;
				j = j;
				l1a += (int) trace_back[i - V_start_last + 1][j - H_start_last + 1].distance;
			}
		 }
	 }
#endif


#ifdef LOCAL_LOCAL
	if (Hmax >= min_local_score) {

	    tmp_Vseq = (char *) calloc((unsigned) nV + 2, sizeof(char));
	    check_calloc(tmp_Vseq, "tmp_Vseq");
	    tmp_Hseq = (char *) calloc((unsigned) nH + 2, sizeof(char));
	    check_calloc(tmp_Hseq, "tmp_Hseq");

#if 0
strcpy(tmp_Vseq + 1, Vseq + 1);
strcpy(tmp_Hseq + 1, Hseq + 1);
for(k = 1; k < end_i; k++)
    tmp_Vseq[k] = '-';
for(k = start_i+1; k <= nV; k++)
    tmp_Vseq[k] = '-';
for(k = 1; k < end_j; k++)
    tmp_Hseq[k] = '-';
for(k = start_j+1; k <= nH; k++)
    tmp_Hseq[k] = '-';
/* printf("Vseq=%s\nHseq=%s\nHmax=%d\n", tmp_Vseq, tmp_Hseq, Hmax); */
#endif


	    /* do upper-left quadrant */

	    LOi = end_i;
	    LOj = end_j;
	    UPi = UPi_last;
	    UPj = UPj_last;

	    if ((end_i - V_start >= min_local_width) && (end_j - H_start >= min_local_width)){

		strcpy(tmp_Vseq + 1, Vseq + 1);
		strcpy(tmp_Hseq + 1, Hseq + 1);
		for(k = end_i; k <= nV; k++)
		    tmp_Vseq[k] = '-';
		for(k = end_j; k <= nH; k++)
		    tmp_Hseq[k] = '-';

/* printf("Doing upper-left\nVseq=%s\nHseq=%s\nHmax=%d\nLOi=%d, LOj=%d, UPi=%d, UPj=%d\n", tmp_Vseq, tmp_Hseq, Hmax, LOi, LOj, UPi, UPj); */

		paths(Vpoint, Hpoint, path1, &l1, path2, &l2,
		      nV, nH, S, start, coeff2A, &tmp_Hmax,
		      coeffg1V, coeffg2V, coeffg1H, coeffg2H,
		      coeffg1, coeff_s, tmp_Vseq, tmp_Hseq, FALSE, &l1a,
		      UPi, UPj, LOi, LOj, &LOLOi, &LOLOj,
		      trace_back, V_start_last, V_end_last, H_start_last, 
		      H_end_last, min_local_score, min_local_width);

		Hmax += tmp_Hmax;

	    } else {


		if ((UPi > -1) && (LOi > -1)) {
/* printf("Linking trace-backs #1\n"); */

                    link_trace_backs(trace_back, LOi, LOj, UPi, UPj, V_start_last, H_start_last);
                }
	    }

	    /* do lower-right quadrant */

	    UPi = start_i;
	    UPj = start_j;
	    LOi = LOi_last;
	    LOj = LOj_last;
		
	    if ((V_end - start_i >= min_local_width) && (H_end - start_j >= min_local_width)) {

		strcpy(tmp_Vseq + 1, Vseq + 1);
		strcpy(tmp_Hseq + 1, Hseq + 1);
		for(k = 1; k <= UPi; k++)
		    tmp_Vseq[k] = '-';
		for(k = 1; k <= UPj; k++)
		    tmp_Hseq[k] = '-';

		LOLOi = LOLOi_last;
		LOLOj = LOLOj_last;
		if (start_i > LOLOi_last)
		    LOLOi = start_i;
		if (start_j > LOLOj_last)
		    LOLOj = start_j;

/* printf("Doing lower-right\nVseq=%s\nHseq=%s\nHmax=%d\nLOi=%d, LOj=%d, UPi=%d, UPj=%d\n", tmp_Vseq, tmp_Hseq, Hmax, LOi, LOj, UPi, UPj); */

		paths(Vpoint, Hpoint, path1, &l1, path2, &l2,
		      nV, nH, S, start, coeff2A, &tmp_Hmax,
		      coeffg1V, coeffg2V, coeffg1H, coeffg2H,
		      coeffg1, coeff_s, tmp_Vseq, tmp_Hseq, FALSE, &l1a,
		      UPi, UPj, LOi, LOj, &LOLOi, &LOLOj,
		      trace_back, V_start_last, V_end_last, H_start_last, 
		      H_end_last, min_local_score, min_local_width);

		Hmax += tmp_Hmax;

	    } else {

		if ((UPi > -1) && (LOi > -1)) {
/* printf("Linking trace-backs #2 \n"); */

                    link_trace_backs(trace_back, LOi, LOj, UPi, UPj, V_start_last, H_start_last);
                }
	    }

	    *p_LOLOi = MAX(MAX(LOLOi, LOLOi_last), start_i);
	    *p_LOLOj = MAX(MAX(LOLOj, LOLOj_last), start_j);

	    free((char *) tmp_Vseq);
	    free((char *) tmp_Hseq);
	    
	} else {
	    
/* printf("Failed: Hmax=%d\nVseq=%s\nHseq=%s\n", Hmax, Vseq, Hseq); */

	    if ((UPi > -1) && (LOi > -1)) {
/* printf("Linking trace-backs #3\n"); */
/* printf("LOi=%d, LOj=%d, UPi=%d, UPj=%d\n", LOi, LOj, UPi, UPj); */

                link_trace_backs(trace_back, LOi, LOj, UPi, UPj, V_start_last, H_start_last);
	    }

            if ( (UPi_last == -1) && (LOi_last == -1) ) {
	    /* if last loop */
		*p_LOLOi = start_i;
		*p_LOLOj = start_j;
	    } else {

		*p_LOLOi = LOLOi_last;
		*p_LOLOj = LOLOj_last;

		Hmax = 0;
	    }
	}

#endif


/* Do the final trace-back if coming-out of the last recursive loop */

#ifdef LOCAL_LOCAL
/* printf("Just before final traceback: LOi=%d, LOj=%d, UPi=%d, UPj=%d\n", LOi, LOj, UPi, UPj); */
    if ( (UPi_last == -1) && (LOi_last == -1) ) {
	start[ROW] = *p_LOLOi;
	start[COLUMN] = *p_LOLOj;
	V_start = V_start_last;
	V_end   = V_end_last;
	H_start = H_start_last;
	H_end   = H_end_last;

/* printf("Doing final trace-back\n"); */

#endif
	i = start[ROW];
	j = start[COLUMN];
	l1 = 0;
	l1a = 0;
	if (mso == FALSE) {
		while (trace_back[i - V_start + 1][j - H_start + 1].distance > 0) {
			l1++;
/* printf("i2=%d, j2=%d\n", i,j); */
			if (trace_back[i - V_start + 1][j - H_start + 1].direction == NWEST) {
				path1[ROW][l1] = i - 1;
				path1[COLUMN][l1] = j - 1;
#if 0
				path1[ROW][l1] = i - (int) trace_back[i - V_start + 1][j - H_start + 1].distance;
				path1[COLUMN][l1] = j - (int) trace_back[i - V_start + 1][j - H_start + 1].distance;
#endif
				l1a++;
			}
			else if (trace_back[i - V_start + 1][j - H_start + 1].direction == WEST) {
				path1[ROW][l1] = i;
				path1[COLUMN][l1] = j - (int) trace_back[i - V_start + 1][j - H_start + 1].distance;
				l1a += (int) trace_back[i - V_start + 1][j - H_start + 1].distance;
			} else {
				path1[ROW][l1] = i - (int) trace_back[i - V_start + 1][j - H_start + 1].distance;
				path1[COLUMN][l1] = j;
				l1a += (int) trace_back[i - V_start + 1][j - H_start + 1].distance;
			}
			i = path1[ROW][l1];
			j = path1[COLUMN][l1];
		}

#if 0
		i = start[ROW];
		j = start[COLUMN];
		l2 = 0;

		while (trace_back[i - V_start + 1][j - H_start + 1].distance > 0) {
			l2 = l2 + 1;
			if (trace_back[i - V_start + 1][j - H_start + 1].direction == NWEST) {
				path2[ROW][l2] = i - 1;
				path2[COLUMN][l2] = j - 1;
			}
			else if (trace_back[i - V_start + 1][j - H_start + 1].direction == NORTH) {
				path2[ROW][l2] = i - (int) trace_back[i - V_start + 1][j - H_start + 1].distance;
				path2[COLUMN][l2] = j;
			} else {
				path2[ROW][l2] = i;
				path2[COLUMN][l2] = j - (int) trace_back[i - V_start + 1][j - H_start + 1].distance;
			}
			i = path2[ROW][l2];
			j = path2[COLUMN][l2];
		}
#endif
	}
#ifdef LOCAL_LOCAL
    }
#endif


#if 0
	printf("%d\n", Hmax);
#endif
	*p_Hmax = Hmax;
	*p_l1 = l1;
	*p_l2 = l2;
	*p_l1a = l1a;

#ifndef LOCAL_LOCAL
	if (mso == FALSE) {
		for (k = 0; k <= V_end - V_start; k++)
			free((char *) trace_back[k]);
		free((char *) trace_back);
	}
#endif
	free((char *) H[0]);
	free((char *) H[1]);
	free((char *) H);
	free((char *) LNi);
	free((char *) H_LNi);
	free((char *) LNi_g);
	free((char *) H_LNi_g);
	free((char *) coeffg1V_LNi);

}

#ifdef LOCAL_LOCAL
void
link_trace_backs(DIRECTION_VALUES **trace_back, int LOi, int LOj, int UPi, int UPj, int V_start, int H_start)
{
    int i;

/* printf("LOi=%d, LOj=%d, UPi=%d, UPj=%d\n", LOi, LOj, UPi, UPj); */

    if ((LOi - UPi) == (LOj - UPj)) {
	for (i = 0; i < LOj - UPj; i++) {
	    trace_back[LOi-i - V_start + 1][LOj-i - H_start + 1].distance =  1;
	    trace_back[LOi-i - V_start + 1][LOj-i - H_start + 1].direction = NWEST;
	}
    } else if ((LOi - UPi) > (LOj - UPj)) {
	for (i = 0; i < LOj - UPj; i++) {
	    trace_back[LOi-i - V_start + 1][LOj-i - H_start + 1].distance =  1;
	    trace_back[LOi-i - V_start + 1][LOj-i - H_start + 1].direction = NWEST;
	}
	trace_back[LOi - (LOj - UPj) - V_start + 1][UPj - H_start + 1].distance =  (LOi - UPi) - (LOj - UPj);
	trace_back[LOi - (LOj - UPj) - V_start + 1][UPj - H_start + 1].direction = NORTH;
    } else {
	for (i = 0; i < LOi - UPi; i++) {
	    trace_back[LOi-i - V_start + 1][LOj-i - H_start + 1].distance = 1;
	    trace_back[LOi-i - V_start + 1][LOj-i - H_start + 1].direction = NWEST;
	}
	trace_back[UPi - V_start + 1][LOj - (LOi - UPi) - H_start + 1].distance =  (LOj - UPj) - (LOi - UPi);
	trace_back[UPi - V_start + 1][LOj - (LOi - UPi) - H_start + 1].direction = WEST;
    }
}
#endif

