#include <pima_lib.h>

void
read_matrix(FILE *fp, char *AA_chars, char (*C)[MAXAR], int (*S)[MAXAR], int *n_AA, float *f_min_local_score, float *f_coeff1, float *f_coeff2)
{
    char line[MAXAR * 2];
    int i, j, len;

    fgets(line, sizeof(line), fp);
    sscanf(line, "%f %f %f", f_min_local_score, f_coeff1, f_coeff2);
    
    fgets(line, sizeof(line), fp);
    len = strlen(line);
    if (line[len - 1] == '\n') {
	len--;
	line[len] = '\0';
    }

    /* The actual maximum is one less than the size since one indexing is used.
     */
    if (len > MAXAR - 1) {
	fprintf(stderr, "%s: matrix dimension of %d exceeds max of %d.\n",
		program_name, len, MAXAR - 1);
	exit(1);
    }

    *n_AA = len;
    strcpy(AA_chars, line);
    change_index(AA_chars, &len);

    for (i = 1; i <= len; i++) {
	for (j = 1; j <= len; j++) {
	    fscanf(fp, "%d", &S[i][j]);
	    S[i][j] *= 100;	/* matrix elements multiplied by 100 */
	}
    }

    /* Read final newline not read by fscanf. */
    fgets(line, sizeof(line), fp);
    if (line[0] != '\n') {
	fprintf(stderr, "%s: fscanf error, newline not found.\n",
		program_name);
	exit(1);
    }

    for (i = 1; i <= len; i++) {
	fgets(line, sizeof(line), fp);
	for (j = 1; j <= len; j++) {
	    C[i][j] = line[j - 1];
	}
    }

    if (ferror(fp)) {
	fprintf(stderr, "%s: error reading matrix.\n", program_name);
	exit(1);
    }
    fclose(fp);
}
