/*
 * close.c - Close the fp associated with a file and free the memory.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

#include <config.h>
#include <memu_macros.h>
#include <sequ.h>

void
sequ_close(sequ_file_t *file)
{
    if (file->fp != NULL) {
	if (fclose(file->fp) != 0) {
	    fprintf(stderr,
		    "%s: error closing file named '%s'\n",
		    program_name,
		    file->filename);
	    abort();
	}
    }
    if (file->last_line)
	memu_free_m(file->last_line);
    memu_free_m(file);
}
