/* Do not edit this file.
 * It is automatically generated.
 */

/*
 * _sequ_getline.c - Read a line from a file, allocating the memory.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

#include <config.h>
#include <memu_macros.h>
#include <sequ.h>

#define INPUT_BUFFER_SIZE	1024

char *
_sequ_getline(FILE *fp, size_t *length_p)
{
    char input_buffer[INPUT_BUFFER_SIZE];
    size_t	length;
    size_t	n;
    char	*p;
    int		have_complete_line;

    /* Check that we haven't already hit end-of-file.  The last time
     * this function was called an incomplete line might have been
     * returned.  Thus an end-of-file was encountered but not returned.
     */
    if (feof(fp) != FALSE)
	return(NULL);

    p = NULL;
    length = 0;
    have_complete_line = FALSE;
    do {
	/* Read a line, or atleast a buffer full of the beginning of a line. */
	if (fgets(input_buffer, sizeof(input_buffer), fp) == NULL) {

	    /* Make sure it failed due to EOF. */
	    if (feof(fp) == FALSE) {
		fprintf(stderr,
			"%s: read error on %d\n",
			program_name,
			fileno(fp));
		abort();
	    }

	    /* Return an incomplete line even though there was no newline. */
	    if (p != NULL)
		goto RETURN_LINE;

	    return(NULL);
	}

	/* Don't need to allocate space for the newline if we have a complete
	 * line.  So now is a good a time as any to see if this line is
	 * complete and get rid of the newline since we don't want to copy
	 * it anyways.  If this line is not complete yet (doesn't have a
	 * newline at the end) then we need to keep reading.
	 */
	n = strlen(input_buffer);
	if (input_buffer[n - 1] == '\n') {
	    have_complete_line = TRUE;
	    n--;
	    input_buffer[n] = '\0';
	}

	if (p == NULL)
	    memu_new_m(p, char, n + 1);
	else
	    memu_resize_m(p, char, length + n + 1);

	strcpy(p + length, input_buffer);
	length += n;

    } while (have_complete_line == FALSE);

 RETURN_LINE:
    if (length_p)
	*length_p = length;

    return(p);
}
