/*
 * name.c - Determine the name of a file format.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

#include <config.h>
#include <sequ.h>

/* Return the name of a file format.
 */

char *
sequ_format_to_name(sequ_format_t format)
{
    switch(format) {
    case sequ_format_tbl:
	return("tbl");
	break;
    case sequ_format_fasta:
	return("fasta");
	break;
    case sequ_format_ig:
	return("ig");
	break;
    case sequ_format_gb:
	return("gb");
	break;
    case sequ_format_nbrf:
	return("nbrf");
	break;
    case sequ_format_embl:
	return("embl");
	break;
    case sequ_format_pir:
	return("pir");
	break;
    default:
	return("unknown");
	break;
    }

    /* NOTREACHED */
    return(NULL);
}
