/*
 * rewind.c - Rewind fp associated with a file and free any buffered lines.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

#include <config.h>
#include <memu_macros.h>
#include <sequ.h>

void
sequ_rewind(sequ_file_t *file)
{
    if (file->last_line) {
	memu_free_m(file->last_line);
	file->last_line = NULL;
    }
    rewind(file->fp);
    file->did_first = FALSE;
}
