/*
 * seek.c - Seek to specified position of fp associated with a file and free any buffered lines.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

#include <config.h>
#include <memu_macros.h>
#include <sequ.h>

void
sequ_seek(sequ_file_t *file, long offset, int ptrname)
{
    int ret;

    if (file->last_line) {
	memu_free_m(file->last_line);
	file->last_line = NULL;
    }
    ret = fseek(file->fp, offset, ptrname);
    if (ret != 0) {
	fprintf(stderr,
		"%s: error seeking to offset of '%ld' from '%d'\n",
		program_name,
		offset,
		ptrname);
	abort();
    }
    if (offset == 0 && ptrname == 0)
	file->did_first = FALSE;
}
