/*
 * sequ_lib.h - Header file for files in sequ utility library.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

#ifndef sequ_lib_h
#define sequ_lib_h

#ifndef FASTA_WIDTH
#define FASTA_WIDTH 50
#endif

#ifndef IG_WIDTH
#define IG_WIDTH 50
#endif

#ifndef GB_WIDTH
#define GB_WIDTH 50
#endif

#ifndef GB_GROUP
#define GB_GROUP 10
#endif

#ifndef NBRF_WIDTH
#define NBRF_WIDTH 50
#endif

#ifndef NBRF_GROUP
#define NBRF_GROUP 10
#endif

#ifndef EMBL_WIDTH
#define EMBL_WIDTH 60
#endif

#ifndef EMBL_GROUP
#define EMBL_GROUP 10
#endif

#ifndef PIR_WIDTH
#define PIR_WIDTH 30
#endif

#ifndef PIR_HEADING
#define PIR_HEADING "                5        10        15        20        25        30\n"
#endif


void _sequ_read_tbl(sequ_seq_t *seq, sequ_file_t *file);
void _sequ_read_fasta(sequ_seq_t *seq, sequ_file_t *file);
void _sequ_read_ig(sequ_seq_t *seq, sequ_file_t *file);
void _sequ_read_gb(sequ_seq_t *seq, sequ_file_t *file);
void _sequ_read_nbrf(sequ_seq_t *seq, sequ_file_t *file);
void _sequ_read_embl(sequ_seq_t *seq, sequ_file_t *file);
void _sequ_read_pir(sequ_seq_t *seq, sequ_file_t *file);
void _sequ_write_tbl(sequ_file_t *file, sequ_seq_t *seq);
void _sequ_write_fasta(sequ_file_t *file, sequ_seq_t *seq);
void _sequ_write_ig(sequ_file_t *file, sequ_seq_t *seq);
void _sequ_write_gb(sequ_file_t *file, sequ_seq_t *seq);
void _sequ_write_nbrf(sequ_file_t *file, sequ_seq_t *seq);
void _sequ_write_embl(sequ_file_t *file, sequ_seq_t *seq);
void _sequ_write_pir(sequ_file_t *file, sequ_seq_t *seq);

#endif /* not defined sequ_lib_h */
