/*
 * tell.c - Return the current position in fp associated with a file that is useable by the seek routine.
 *
 * Copyright (C) 1994 Baylor College of Medicine
 *
 * All rights reserved.
 *
 * Contact Brent Wiese, brent@bcm.tmc.edu
 */

#include <config.h>
#include <memu_macros.h>
#include <sequ.h>

long
sequ_tell(sequ_file_t *file)
{
    long position;

    position = ftell(file->fp);
    if (file->last_line != NULL)
	position -= file->last_line_length + 1; /* Add one for the newline. */
    return(position);
}
