/***************************************************************************/
#include "plsearch.h"
#include <sequ.h>
#define PLS

void
get_alignment(score_record *record, FILE *finp_pat, FILE *finp_query, FILE *foutp_align, int coeff1, int coeff2, int coeff3, long int *coeff2A, int (*S)[MAXAR], char *AAseq, int nAA, int max_display, sequ_file_t *pat_file, sequ_file_t *query_file, int type)
{

	char **Vseq, **Vname, **Vtitle, **Hseq, **Hname, **Htitle;
	char line[20000],
	name[500];
	int Hmax;
	int *coeff1gH,
	*coeff2gH,
	*coeff1gV,
	*coeff2gV;

	int nS,
	nV,
	nH,
	n_Vseqs = 0,
	n_Hseqs = 0,
	len;
	int *Vpoint,
	*Hpoint,
	start[3],
	**path1,
	**path2,
	l1,
	l2,
	i;	
	char C[MAXAR][MAXAR];
	char Sname[100],
	Sext[100];

	sequ_seq_t *Hseq_seq, *Vseq_seq;
	
	int aligned_len;
	int j, num;
	int max_pat_score, max_query_score, max_align_score;
	float score;
	char title[400]; 


	Vseq = (char **) calloc((unsigned) max_display + 1, sizeof(char *));
	Vname = (char **) calloc((unsigned) max_display + 1, sizeof(char *));
	Vtitle = (char **) calloc((unsigned) max_display + 1, sizeof(char *));
	Hseq = (char **) calloc((unsigned) max_display + 1, sizeof(char *));
	Hname = (char **) calloc((unsigned) max_display + 1, sizeof(char *));
	Htitle = (char **) calloc((unsigned) max_display + 1, sizeof(char *));


	for (num = 0; num < max_display; num++) {

		/* Get query (Vseq) from finp_query */

		sequ_seek(query_file, record[num].V_seq_ftell, 0);

		Vseq_seq = sequ_read(query_file);
		if (Vseq_seq == NULL) abort();

		len = Vseq_seq->length;

		Vseq[num] = (char *) calloc((unsigned) len + 2, sizeof(char));
		check_calloc((int *) Vseq[num], "Vseq during final alignment in main()");

		Vname[num] = (char *) calloc((unsigned) strlen(Vseq_seq->id) + 2,
		    sizeof(char));
		check_calloc((void *) Vname[num], "Vname in main()");
		
		if (Vseq_seq->title == NULL) {
			Vtitle[num] = (char *) calloc((unsigned) 2,sizeof(char));
			check_calloc((void *) Vtitle[num], "Vname in main()");
			strcpy(Vtitle[num], "");
		} else {
			Vtitle[num] = (char *) calloc((unsigned) strlen(Vseq_seq->title) + 2,
										  sizeof(char));
			check_calloc((void *) Vtitle[num], "Vname in main()");
			strcpy(Vtitle[num], Vseq_seq->title);
		}

#if 0
		Vseq[num] = Vseq_seq->seq;
		Vname[num] = Vseq_seq->id;
		Vtitle[num] = Vseq_seq->title;
#else
		strcpy(Vname[num], Vseq_seq->id);
		strcpy(Vseq[num], Vseq_seq->seq);
#endif
		/* Get pattern (Hseq) from finp_pat  */

		sequ_seek(pat_file, record[num].H_seq_ftell, 0);

		Hseq_seq = sequ_read(pat_file);
		if (Hseq_seq == NULL) abort();

		len = Hseq_seq->length;

		Hseq[num] = (char *) calloc((unsigned) len + 2, sizeof(char));
		check_calloc((int *) Hseq[num], "Hseq during final alignment in main()");

		Hname[num] = (char *) calloc((unsigned) strlen(Hseq_seq->id) + 2,
		    sizeof(char));
		check_calloc((void *) Hname[num], "Hname in main()");

		if (Hseq_seq->title == NULL) {
			Htitle[num] = (char *) calloc((unsigned) 2, sizeof(char));
			check_calloc((void *) Htitle[num], "Hname in main()");
			strcpy(Htitle[num], "");
		} else {
			Htitle[num] = (char *) calloc((unsigned) strlen(Hseq_seq->title) + 2,
										  sizeof(char));
			check_calloc((void *) Htitle[num], "Hname in main()");
			strcpy(Htitle[num], Hseq_seq->title);
		}

#if 0
		Hseq[num] = Hseq_seq->seq;
		Hname[num] = Hseq_seq->id;
		Htitle[num] = Hseq_seq->title;
#else
		strcpy(Hseq[num], Hseq_seq->seq);
		strcpy(Hname[num], Hseq_seq->id);
#endif

#if 0
		free(Vseq_seq);
		free(Hseq_seq);
#else
		sequ_seq_free(Vseq_seq);
		sequ_seq_free(Hseq_seq);
#endif


		switch(type) {
		case 1:
			fprintf(foutp_align, "%-9.9s  %-16.16s  %-44.44s  %3.1f\n",
				Vname[num], Hname[num], Htitle[num],
				(float) record[num].raw_score/100.0);
			break;
		case 2:
			fprintf(foutp_align, "%-9.9s  %-16.16s  %-44.44s  %3.1f\n",
				Vname[num], Hname[num], Htitle[num],
				(float) record[num].percent_score/100.0);
			break;
		case 3:
			fprintf(foutp_align, "%-9.9s  %-16.16s  %-44.44s  %3.1f\n",
				Vname[num], Hname[num], Htitle[num],
				(float) record[num].percent_align_score/100.0);
			break;
		}

	}

	fprintf(foutp_align, "\n\n");

	for (num = 0; num < max_display; num++) {
		setup_seq(Vseq[num], Vname[num], AAseq, nAA, coeff1, coeff2,
				  &nV, &Vpoint, &coeff1gV, &coeff2gV);


		setup_seq(Hseq[num], Hname[num], AAseq, nAA, coeff1, coeff2,
				  &nH, &Hpoint, &coeff1gH, &coeff2gH);


			if (nV * nH >= (MAX_H_DIM * MAX_H_DIM)) {
				if (nV <= nH) {
					if (nV >= MAX_H_DIM)
						nV = nH = MAX_H_DIM;
					else
						nH = MIN(nH, (MAX_H_DIM *MAX_H_DIM)/nV);
				} else {
					if (nH >= MAX_H_DIM)
						nV = nH = MAX_H_DIM;
					else
						nV = MIN(nV, (MAX_H_DIM * MAX_H_DIM)/nH);
				}
			}


			path1 = (int **) calloc((unsigned) 3, sizeof(int *));

			check_calloc((int *) path1, "path1");
			path2 = (int **) calloc((unsigned) 3, sizeof(int *));

			check_calloc((int *) path2, "path2");
			for (j = 0; j <= 2; j++) {


				path1[j] = (int *) calloc((unsigned) nV + nH,
				    sizeof(int));

				check_calloc(path1[j], "path1[j]");
				path2[j] = (int *) calloc((unsigned) nV + nH,
				    sizeof(int));

				check_calloc(path2[j], "path2[j]");
			}

			paths(Vpoint, Hpoint, path1, &l1, path2, &l2,
				  nV, nH, S, start, coeff2A, &Hmax,
				  coeff1gV, coeff2gV, coeff1gH, coeff2gH,
				  coeff1, coeff3, Vseq[num], Hseq[num], FALSE, &aligned_len);

			score = (float) (Hmax / 100.0);

			max_query_score = 0;
			for (i = 1; i <= nV; i++)	
				max_query_score += S[Vpoint[i]][Vpoint[i]];

			max_pat_score = max_align_score = 0;
			for (i = 1; i <= nH; i++)
				max_pat_score += S[Hpoint[i]][Hpoint[i]];
			for (i = path1[2][l1]+1; i <= start[2]; i++)
				max_align_score += S[Hpoint[i]][Hpoint[i]];
#if 0
			fprintf(stdout, "%s\t%s\t%g\t%g\t%g\t%g\t%g\t%g\n",
				    Vname[num], Hname[num], score, (float)Hmax/max_query_score,
				    (float) max_pat_score/100.0, (float) Hmax/max_pat_score,
				    (float) max_align_score/100.0, 
				    (float) Hmax/max_align_score);
#endif


			fprintf(foutp_align, "Query: %s \"%-s\"\n", 
					Vname[num], Vtitle[num]);
			fprintf(foutp_align, "Sbjct: %s \"%-s\"\n\n", 
					Hname[num], Htitle[num]);

		    switch (type) {
			case 1:
				fprintf(foutp_align, "Percent of max. Query score: %.1f%%\n", 
						(float) Hmax * 100.0/max_query_score);
				fprintf(foutp_align, "                             ____\n");
				fprintf(foutp_align, "Raw score: %g\n", score);
				fprintf(foutp_align, "Percent of max. Pattern score: %.1f%%\n", 
						(float) Hmax * 100.0/max_pat_score);
				fprintf(foutp_align, "Percent of max. Local Alignment score: %.1f%%\n", 
						(float) Hmax * 100.0/max_align_score);
				fprintf(foutp_align, "\n\n");
				break;
			case 2:
				fprintf(foutp_align, "Percent of max. Pattern score: %.1f%%\n", 
						(float) Hmax * 100.0/max_pat_score);
				fprintf(foutp_align, "                               ____\n");
				fprintf(foutp_align, "Raw score: %g\n", score);
				fprintf(foutp_align, "Percent of max. Query score: %.1f%%\n", 
						(float) Hmax * 100.0/max_query_score);
				fprintf(foutp_align, "Percent of max. Local Alignment score: %.1f%%\n", 
						(float) Hmax * 100.0/max_align_score);
				fprintf(foutp_align, "\n\n");
				break;
			case 3:
				fprintf(foutp_align, "Percent of max. Local Alignment score: %.1f%%\n", 
						(float) Hmax * 100.0/max_align_score);
				fprintf(foutp_align, "                                       ____\n");
				fprintf(foutp_align, "Raw score: %g\n", score);
				fprintf(foutp_align, "Percent of max. Query score: %.1f%%\n", 
						(float) Hmax * 100.0/max_query_score);
				fprintf(foutp_align, "Percent of max. Pattern score: %.1f%%\n", 
						(float) Hmax * 100.0/max_pat_score);
				fprintf(foutp_align, "\n\n");
				break;
			}

			n_Vseqs = n_Hseqs = 1;

			print_alignment(C, Vpoint, Hpoint, path1, path2,
			    l1, foutp_align, Vseq, Hseq, nV, nH, n_Vseqs, n_Hseqs,
			    Vname, Hname, Sname, Sext, S, num);

		    fprintf(foutp_align, "\n\n");


			for (j = 0; j <= 2; j++) {
				free((char *) path1[j]);
				free((char *) path2[j]);
			}
			free((char *) path1);
			free((char *) path2);

			free((char *) Vpoint);
			free((char *) coeff1gV);
			free((char *) coeff2gV);
			free((char *) coeff1gH);
			free((char *) coeff2gH);
			free((char *) Hpoint);

#if 1
			free((char *) Vname[num]);
			free((char *) Vtitle[num]);
			free((char *) Vseq[num]);

			free((char *) Hname[num]);
			free((char *) Htitle[num]);
			free((char *) Hseq[num]);
#endif

    }
#if 1
	free((char *) Vname);
	free((char *) Vtitle);
	free((char *) Vseq);

	free((char *) Hname);
	free((char *) Htitle);
	free((char *) Hseq);
#endif


}
