/***************************************************************************/
#include "plsearch.h"
#define PLS

void
get_responses(char *program_name, int default_p, int sec_structs_p, char *query_filename, char *root_filename, char *
pattern_filename, int *p_coeff1, int *p_coeff2, int *p_coeff3, float *p_gpr_f, char *ss_chars, int *p_no_param_file, float
*p_score_cutoff, float *p_display_cutoff, FILE **file_handle, char (*C)[MAXAR], float *p_W2_atten, int *p_no_titles_file, char
*Sname, char *Sext,
int *p_max_display, int *p_do_detach)
{
	char weightmat_name[60];
	float get_float_or_default(float dfault);
	FILE *finp_query,
	    *finp_weightmat;
	FILE *finp_pat,
	    *foutp_align,
	    *foutp_tmp;
	int not_found;
	char *getenv_p;
	char filename[80],
	path[80];
	float W2_atten;
#ifdef PLS
	int search_type;
	FILE *foutp_raw, *foutp_percent, *foutp_aligned;
#endif

	/* Find path to auxillarily files ------------------------------- */

	strcpy(path, "");
	/* PLSEARCH_HOME is set in the 'plsearch.h' file  */
	if (strcmp(PLSEARCH_HOME, "")) {
		strcpy(path, PLSEARCH_HOME);
		strcat(path, "/");
	}
#if UNIX == TRUE
	/* PLSEARCH_HOME is set as an environmental variable  */
	getenv_p = getenv("PLSEARCH_HOME");
	if (getenv_p != NULL) {
		strcpy(path, getenv_p);
		strcat(path, "/");
	}
#endif

#ifdef PLS
	/* Get search type ---------------------------------------------- */

	search_type = 0;
	if (default_p) {
	    if (!strcmp(pattern_filename, ""))
		search_type = 1;
	    else
		search_type = 2;
	} else {
		fprintf(stdout,
		    "\n>>> hit Return to enter default [ ] values <<<\n\n");
		fflush(stdout);
		do {
			fprintf(stdout, "\
Enter type of search:\n");
			fflush(stdout);
			fflush(stdout);
			fprintf(stdout, "\
  1= Sequence vs. PLSEARCH Pattern Library\n");
			fflush(stdout);
			fprintf(stdout, "\
  2= User-constructed pattern vs. a seq. DB or other seq. sets\n");
			fflush(stdout);

			fprintf(stdout, " --> Search type [1]: ");
			fflush(stdout);
			search_type = (int) get_float_or_default(1.0);
			if ((search_type != 1) && (search_type != 2) && (search_type != 3)) {
				fprintf(stderr, "ERROR: Incorrect option; re-enter #\n");
				fflush(stderr);
				search_type = 0;
			}
		} while (search_type == 0);
	}

	fprintf(stdout, "\n");

	/* print all alignments */
	/* if (search_type == 2)  *p_show_all = 1;       */
#endif /* PLS */


	/* Read in query filename  ------------------------------------------ */

	if (default_p) {
		if (!(finp_query = fopen(query_filename, "r"))) {
			fprintf(stderr, "query-file \"%s\" not found\n",

			    query_filename);
			exit(1);
		}
	} else {

		do {
			not_found = 0;

			if (search_type == 1) {
				fprintf(stdout, "%s", "Name of QUERY sequence file (no default): ");
				get_string_or_default(" ", query_filename);
				if (!(finp_query = fopen(query_filename, "r"))) {
				    fprintf(stderr, "query-file \"%s\" not found, re-enter name\n",
					    query_filename);
				    not_found = 1;
				}
			} else {
				fprintf(stdout, "%s", "Name of QUERY pattern file (no default): ");
				get_string_or_default(" ", pattern_filename);
				if (!(finp_pat = fopen(pattern_filename, "r"))) {
				    fprintf(stderr, "sequence file %s not found, re-enter name\n",
					    pattern_filename);
				    not_found = 1;
				}
			}
		} while (not_found);
	}


	/* Read in pattern filename  -------------------------------------- */


	if ((search_type == 1) || default_p) {
	    if (search_type == 1) {
		strcpy(pattern_filename, path);
		strcat(pattern_filename, "patterns.pls");
            }
	    if (!(finp_pat = fopen(pattern_filename, "r"))) {
		fprintf(stderr, "pattern-file %s not found\n",
			pattern_filename);
		exit(1);
	    }
	} else {

		/* PLSEARCH_SEQ_DB_FILE is set as an environmental variable
				 * SEQ_DB_FILE is set in plsearch.h
				 */
		getenv_p = getenv("PLSEARCH_SEQ_DB_FILE");
		if (getenv_p != NULL) {
			strcpy(filename, (char *) getenv_p);
		} else
			strcpy(filename, SEQ_DB_FILE);

/*		fprintf(stdout, "\n"); */

		do {
			not_found = 0;
			fprintf(stdout, 
			    "Name of sequence file to be searched [%s]: ", filename);
			get_string_or_default(filename, query_filename);
			if (!(finp_query = fopen(query_filename, "r"))) {
				fprintf(stderr, "sequence file %s not found, re-enter name\n",

				    query_filename);
				not_found = 1;
			}
		} while (not_found);
	}


	/* Read in output filename  -------------------------------------- */

	if (!default_p) {
	    do {
		fprintf(stdout, "%s", "BASE name for OUTPUT files ( 3 output files will created with\n");
		fprintf(stdout, "%s", "  the extensions .1 .2 .3 (no default): ");
		get_string_or_default(" ", root_filename);
		if (!strcmp(root_filename , " "))
		    fprintf(stderr, "  ERROR: no name given; Re-enter name\n");
	    } while (!strcmp(root_filename , " "));
#if 0	    
	    foutp_align = fopen(root_filename, "w");
#endif
	}

	sprintf(filename, "%s%s", root_filename, ".1");
	foutp_raw = fopen(filename, "w+");
	sprintf(filename, "%s%s", root_filename, ".2");
	foutp_percent = fopen(filename, "w+");
	sprintf(filename, "%s%s", root_filename, ".3");
	foutp_aligned = fopen(filename, "w+");

/*	foutp_tmp = tmpfile(); */
/*	foutp_tmp = fopen(TMP_FILE_NAME, "w+"); */
	foutp_tmp = fopen(strcat(root_filename, "~"), "w+");

	/* Get gap-penality values --------------------------------------- */

	if (default_p) {
		*p_coeff1 = (int) (W1a * 100.0);
		*p_coeff2 = (int) (W2 * 100.0);
		W2_atten = W2_ATTEN;
		*p_W2_atten = W2_atten;

		*p_coeff3 = (int) (W3 * 100.0);

	} else {
		fprintf(stdout, "Enter length-INDEPEND. gap penalty      [%1.2f]: ",
		    W1b);
		*p_coeff1 = (int) (get_float_or_default(W1a) * 100.0);

		fprintf(stdout, "Enter length-DEPEND. gap penalty        [%1.2f]: ",
		    W2);
		*p_coeff2 = (int) (get_float_or_default(W2) * 100.0);

#ifndef PLS
		fprintf(stdout, "Enter length-DEPEND. penalty ATTENUATOR [%1.2f]: ",
		    W2_ATTEN);
		W2_atten = get_float_or_default(W2_ATTEN);
#else
		W2_atten = W2_ATTEN;
#endif

		*p_W2_atten = W2_atten;

#ifndef PLS
		if (sec_structs_p) {
			fprintf(stdout,
			    "Enter sec-struct-depend gap penalty     [%2.1f]: ", W3);
			*p_coeff3 = (int) (get_float_or_default(W3) * 100.0);
		}
#endif
	}


#ifndef PLS
	/* ---- Get sec-struct chars that are to be gap-constrained (if any) */

	strcpy(ss_chars, SS_CHARS);
	if (!default_p && sec_structs_p) {
		fprintf(stdout, "\n");
		fprintf(stdout, "Enter sec-struct chars to be gap-constrained [%s]: ",
		    ss_chars);
		get_string_or_default(ss_chars, ss_chars);
	}
#endif

	/* Read in weight matrix ----------------------------------------- */

	strcpy(filename, path);
	strcat(filename, "weight2-.mat");

	if (default_p) {
/*	if (default_p || TRUE) {  */
		if (!(finp_weightmat = fopen(filename, "r"))) {
			fprintf(stderr, "weight-matrix file %s not found",
			    weightmat_name);
			exit(1);
		}
	} else {
		do {
			not_found = 0;

			fprintf(stdout,
			    "Enter weight-matrix filename [%s]   : ",
			    filename);
			get_string_or_default(filename, weightmat_name);
			if (!(finp_weightmat = fopen(weightmat_name,
			    "r"))) {
				fprintf(stderr,
				    ">> weight-matrix file \"%s\" not found -- re-enter name\n",
				    weightmat_name);
				not_found = 1;
			}
		} while (not_found);
	}

#ifndef PLS
	/* get aa_class-matrix filename ------ */

	if (TRUE) {
		strcpy(filename, path);
		strcat(filename, "class-pm.mat");

		if (default_p) {
			if (!(finp_aa_classmat = fopen(filename, "r"))) {
				fprintf(stderr, "aa-class-matrix file %s not found",
				    aa_classmat_name);
				exit(1);
			}
		} else {
			do {
				not_found = 0;

				fprintf(stdout,
				    "Enter aa-class-matrix filename [%s]   : ",
				    filename);
				get_string_or_default(filename, aa_classmat_name);
				if (!(finp_aa_classmat = fopen(aa_classmat_name,
				    "r"))) {
					fprintf(stderr,
					    ">> aa-class-matrix file \"%s\" not found -- re-enter name\n",
					    aa_classmat_name);
					not_found = 1;
				}
			} while (not_found);
		}
	}
#endif

#ifndef PLS
	fprintf(stdout, "Cluster ID Name (no default): ");
	get_string_or_default(" ", Sname);
	fprintf(stdout, "Cluster ID Extension (no default): ");
	get_string_or_default(" ", Sext);

	file_handle[0] = finp_param;
	file_handle[2] = foutp_score;
	file_handle[6] = finp_titles;
	file_handle[7] = finp_aa_classmat;
#endif
	file_handle[1] = finp_pat;
	file_handle[3] = foutp_align;
	file_handle[4] = foutp_tmp;
	file_handle[5] = finp_query;
	file_handle[8] = finp_weightmat;

	file_handle[9] = foutp_raw;
	file_handle[10] = foutp_percent;
	file_handle[11] = foutp_aligned;
}
