/***************************************************************************/
#include "plsearch.h"
#define PLS

void
print_alignment(char (*C)[MAXAR], int *Vpoint, int *Hpoint, int **path1, int **path2, int len, FILE *foutp, char **Vseq, char
**Hseq, int nV, int nH, int n_Vseqs, int n_Hseqs, char **Vname, char **Hname, char *Sname, char *Sext, int (*S)[MAXAR], int num)
{
	int i0,
	i1,
	i2,
	j0,
	j1,
	j2;
	int j,
	k,
	m,
	count,
	numgaps;
	int Hstart,
	Vstart,
	count2;
	int gap_1,
	j00,
	j01;
	char **Vpath,
	**Hpath,
	*Spath;

#ifdef PLS
	int first, last;

if (num > 0) {
	Vseq[0] = (char *) calloc((unsigned) nV + 2, sizeof(char));
	Hseq[0] = (char *) calloc((unsigned) nH + 2, sizeof(char));
	Vname[0] = (char *) calloc((unsigned) strlen(Vname[num]) + 2, sizeof(char));
	Hname[0] = (char *) calloc((unsigned) strlen(Hname[num]) + 2, sizeof(char));

	strcpy(Vname[0], Vname[num]);
	strcpy(Hname[0], Hname[num]);
	strcpy(Vseq[0], Vseq[num]);
	strcpy(Hseq[0], Hseq[num]);
}
#endif

	Vpath = (char **) calloc((unsigned) (n_Vseqs + 1), sizeof(char *));

	for (k = 0; k < n_Vseqs; k++) {
		Vpath[k] = (char *) calloc((unsigned) (nV + nH), sizeof(char));

		check_calloc((void *) Vpath[k], "Vpath");
	}
	Hpath = (char **) calloc((unsigned) (n_Hseqs + 1), sizeof(char *));

	for (k = 0; k < n_Hseqs; k++) {
		Hpath[k] = (char *) calloc((unsigned) (nV + nH), sizeof(char));

		check_calloc((void *) Hpath[k], "Hpath");
	}
	Spath = (char *) calloc((unsigned) (nV + nH), sizeof(char));

	check_calloc((void *) Spath, "Spath");

	Hstart = path1[2][1] + 1;
	Vstart = path1[1][1] + 1;

	count = 1;
	if ((nH - Hstart) >= (nV - Vstart)) {
		for (j = nH; j > Hstart; j--) {
			for (k = 0; k < n_Hseqs; k++)
				Hpath[k][count] = Hseq[k][j];
#ifndef PLS
			Spath[count] = '-';
#else
			Spath[count] = ' ';
#endif
			for (k = 0; k < n_Vseqs; k++)
				Vpath[k][count] = '-';
			count++;
		}
		count2 = count - 1;
		for (j = Vstart + 1; j <= nV; j++) {
			for (k = 0; k < n_Vseqs; k++)
				Vpath[k][count2] = Vseq[k][j];
#ifndef PLS
			Spath[count2] = '-';
#else
			Spath[count2] = ' ';
#endif
			count2--;
		}
	} else {
		for (j = nV; j > Vstart; j--) {
			for (k = 0; k < n_Vseqs; k++)
				Vpath[k][count] = Vseq[k][j];
#ifndef PLS
			Spath[count] = '-';
#else
			Spath[count] = ' ';
#endif
			for (k = 0; k < n_Hseqs; k++)
				Hpath[k][count] = '-';
			count++;
		}
		count2 = count - 1;
		for (j = Hstart + 1; j <= nH; j++) {
			for (k = 0; k < n_Hseqs; k++)
				Hpath[k][count2] = Hseq[k][j];
#ifndef PLS
			Spath[count2] = '-';
#else
			Spath[count2] = ' ';
#endif
			count2--;
		}
	}

	i0 = path1[1][1] + 2;
	j0 = path1[2][1] + 2;

	for (j = 1; j <= len; j++) {
		i1 = path1[1][j] + 1;
		j1 = path1[2][j] + 1;
		i2 = path2[1][j] + 1;
		j2 = path2[2][j] + 1;
		if ((i1 == i2) && (j1 == j2)) {
			if (i1 == i0) {
				numgaps = (j0 - j1);
				for (k = 0; k < numgaps; k++) {
					for (m = 0; m < n_Vseqs; m++)
						Vpath[m][count] = '-';
					for (m = 0; m < n_Hseqs; m++)
						Hpath[m][count] = Hseq[m][j0 - 1 - k];
#ifndef PLS
					Spath[count] = 'g';
#else
					Spath[count] = ' ';
#endif
					count++;
				}
			} else if (j1 == j0) {
				numgaps = (i0 - i1);
				for (k = 0; k < numgaps; k++) {
					for (m = 0; m < n_Hseqs; m++)
						Hpath[m][count] = '-';
					for (m = 0; m < n_Vseqs; m++)
						Vpath[m][count] = Vseq[m][i0 - 1 - k];
#ifndef PLS
					Spath[count] = 'g';
#else
					Spath[count] = ' ';
#endif
					count++;
				}
			} else {
				for (m = 0; m < n_Vseqs; m++)
					Vpath[m][count] = Vseq[m][i1];
				for (m = 0; m < n_Hseqs; m++)
					Hpath[m][count] = Hseq[m][j1];
#ifndef PLS
				Spath[count] = C[Vpoint[i1]][Hpoint[j1]];
#else
				switch ((int) ((S[Vpoint[i1]][Hpoint[j1]]) / 100.0)) {
				case -2:
					Spath[count] = 'x';
					break;
				case 0:
					Spath[count] = ' ';
					break;
				case 1:
					Spath[count] = '.';
					break;
				case 2:
					Spath[count] = ':';
					break;
				case 3:
					Spath[count] = '!';
					break;
				case 5:
					Spath[count] = '|';
					break;
				default:
					Spath[count] = '?';
					break;
				}
#endif

				count++;
			}
			i0 = i1;
			j0 = j1;

		} else {
			if ((i1 == i0) || (j1 == j0))
				gap_1 = 0;	/* gap starts in path2 */
				else
				gap_1 = 1;	/* gap starts in path1 */
			j00 = j01 = j;
			while (!((i1 == i2) && (j1 == j2))) {
				j01++;
				i1 = path1[1][j01] + 1;
				j1 = path1[2][j01] + 1;
				i2 = path2[1][j01] + 1;
				j2 = path2[2][j01] + 1;
			}
			for (j = j00; j < j01; j++) {
				if (gap_1) {
					i1 = path1[1][j] + 1;
					j1 = path1[2][j] + 1;
				} else {
					i1 = path2[1][j] + 1;
					j1 = path2[2][j] + 1;
				}
				if (i1 == i0) {
					numgaps = (j0 - j1);
					for (k = 0; k < numgaps; k++) {
						for (m = 0; m < n_Vseqs; m++)
							Vpath[m][count] = '-';
						for (m = 0; m < n_Hseqs; m++)
							Hpath[m][count] = Hseq[m][j0 - 1 - k];
#ifndef PLS
						Spath[count] = 'g';
#else
						Spath[count] = ' ';
#endif					
						count++;
					}
				} else if (j1 == j0) {
					numgaps = (i0 - i1);
					for (k = 0; k < numgaps; k++) {
						for (m = 0; m < n_Hseqs; m++)
							Hpath[m][count] = '-';
						for (m = 0; m < n_Vseqs; m++)
							Vpath[m][count] = Vseq[m][i0 - 1 - k];
#ifndef PLS
						Spath[count] = 'g';
#else
						Spath[count] = ' ';
#endif					
						count++;
					}
				} else {
					for (m = 0; m < n_Vseqs; m++)
						Vpath[m][count] = Vseq[m][i1];
					for (m = 0; m < n_Hseqs; m++)
						Hpath[m][count] = Hseq[m][j1];
#ifndef PLS
					Spath[count] = C[Vpoint[i1]][Hpoint[j1]];
					/* 
					 * if (Spath[count] != 'g') Spath[count] = 'x'; */
#else

					switch ((int) ((S[Vpoint[i1]][Hpoint[j1]]) / 100.0)) {
					case -2:
						Spath[count] = 'x';
						break;
					case 0:
						Spath[count] = ' ';
						break;
					case 1:
						Spath[count] = '.';
						break;
					case 2:
						Spath[count] = ':';
						break;
					case 3:
						Spath[count] = '!';
						break;
					case 5:
						Spath[count] = '|';
						break;
					default:
						Spath[count] = '?';
						break;
					}
#endif

					count++;
				}
				i0 = i1;
				j0 = j1;
			}
			j--;
		}
	}

	if (i1 >= j1) {
		count2 = count;
		for (j = i1 - 1; j > 0; j--) {
			for (k = 0; k < n_Vseqs; k++)
				Vpath[k][count] = Vseq[k][j];
#ifndef PLS
			Spath[count] = '-';
#else
			Spath[count] = ' ';
#endif					
			for (k = 0; k < n_Hseqs; k++)
				Hpath[k][count] = '-';
			count++;
		}
		for (j = j1 - 1; j > 0; j--) {
			for (k = 0; k < n_Hseqs; k++)
				Hpath[k][count2] = Hseq[k][j];
#ifndef PLS
			Spath[count2] = '-';
#else
			Spath[count2] = ' ';
#endif					
			count2++;
		}
	} else {
		count2 = count;
		for (j = j1 - 1; j > 0; j--) {
			for (k = 0; k < n_Hseqs; k++)
				Hpath[k][count] = Hseq[k][j];
#ifndef PLS
			Spath[count] = '-';
#else
			Spath[count] = ' ';
#endif
			for (k = 0; k < n_Vseqs; k++)
				Vpath[k][count] = '-';
			count++;
		}
		for (j = i1 - 1; j > 0; j--) {
			for (k = 0; k < n_Vseqs; k++)
				Vpath[k][count2] = Vseq[k][j];
#ifndef PLS
			Spath[count2] = '-';
#else
			Spath[count2] = ' ';
#endif					
			count2++;
		}
	}
	count--;

	for (k = 0; k < n_Vseqs; k++)
		Vpath[k][0] = '1';
	for (k = 0; k < n_Hseqs; k++)
		Hpath[k][0] = '1';
	Spath[0] = '1';

#ifndef PLS
	fprintf(foutp, "%s.%s\t", Sname, Sext);
	for (j = count; j >= 1; j--)
		fprintf(foutp, "%c", Spath[j]);
	fprintf(foutp, "\n");

	for (k = 0; k < n_Vseqs; k++) {
		fprintf(foutp, "%s.%s\t", Vname[k], Sext);
		fflush(foutp);
		for (j = count; j >= 1; j--)
			fprintf(foutp, "%c", Vpath[k][j]);
		fprintf(foutp, "\n");
		fflush(foutp);
	}

	for (k = 0; k < n_Hseqs; k++) {
		fprintf(foutp, "%s.%s\t", Hname[k], Sext);
		fflush(foutp);
		for (j = count; j >= 1; j--)
			fprintf(foutp, "%c", Hpath[k][j]);
		fprintf(foutp, "\n");
		fflush(foutp);
	}
#else
	if (count > 0) {
		last = count;
		nV = nH = i0 = j0 = 0;
		while (last > 0) {
			first = MAX(1, last - 59);
fprintf(foutp, "%9.9s:  ", Vname[0]);
			for (j = last; j >= first; j--) {
				fprintf(foutp, "%c", Vpath[0][j]);
				if (!strchr(" -", Vpath[0][j]))
					nV++;
			}
			if (nV == i0)
				fprintf(foutp, "\n");
				else
				fprintf(foutp, "  %d\n", nV);
			i0 = nV;
fprintf(foutp, "            ");
			for (j = last; j >= first; j--)
				fprintf(foutp, "%c", Spath[j]);
			fprintf(foutp, "\n");
fprintf(foutp, "%9.9s:  ", Hname[0]);
			for (j = last; j >= first; j--) {
				fprintf(foutp, "%c", Hpath[0][j]);
				if (!strchr(" -", Hpath[0][j]))
					nH++;
			}
			if (nH == j0)
				fprintf(foutp, "\n\n\n");
				else
				fprintf(foutp, "  %d\n\n\n", nH);
			j0 = nH;
			last = last - 60;
		}
	}
#endif

	fflush(foutp);
	for (k = 0; k < n_Vseqs; k++)
		free((char *) Vpath[k]);
	for (k = 0; k < n_Hseqs; k++)
		free((char *) Hpath[k]);
	free((char *) Vpath);
	free((char *) Hpath);
	free((char *) Spath);
}
