/* usage: extract-records [-i] ID-file|- tbl-file */

#define TRUE 1
#define FALSE 0

#include <config.h>
#include <sequ.h>

char *program_name = "extract-records";

int
main (argc, argv)
int argc;
char *argv [];
{   
	FILE *finp_ID = NULL;		/* May be used uninitialized. */
	FILE *finp_tbl;
	char ID[480];
	int ids_only = FALSE;

	sequ_file_t	*seq_file;
	sequ_file_t	*out_file;
	sequ_seq_t	*in_seq;
	char		*seq_file_name;

	argv++;
	if (!strcmp(*argv, "-i")) {
		ids_only = TRUE;
		argv++;
		if (!(finp_tbl = fopen(*argv, "r"))) {
			fprintf(stderr, "ERROR: File \"%s\" not found !!\n", *argv);
			exit(1);
		}
		seq_file_name = *argv;
	}
	else if (argc == 3) {
		if (*argv[0] == '-')
			finp_ID = stdin;
		else if (!(finp_ID = fopen(*argv, "r"))) {
			fprintf(stderr, "ERROR: File \"%s\" not found !!\n", *argv);
			exit(1);
		}
		argv++;
		if (!(finp_tbl = fopen(*argv, "r"))) {
			fprintf(stderr, "ERROR: File \"%s\" not found !!\n", *argv);
			exit(1);
		}
		seq_file_name = *argv;
	} 
	else {
		fprintf(stderr, "Usage: extract-records [-i] ID-file record-file\n");
		exit(1);
	}



	if (!ids_only) {
		seq_file = sequ_new_read_first(&in_seq,
					       seq_file_name,
					       finp_tbl);
		sequ_rewind(seq_file);
		out_file = sequ_new_write("stdout",
					  stdout,
					  seq_file->format);
		while (fscanf(finp_ID, "%s", ID) != EOF) {
		    	in_seq = sequ_read(seq_file);
			while (in_seq != NULL && strcmp(ID, in_seq->id)) {
				sequ_seq_free(in_seq);
				in_seq = sequ_read(seq_file);
			} 
			if (in_seq == NULL) {
			    fprintf(stderr,
				    "ERROR: locus \"%s\" NOT found !!; continuing ...\n", ID);
			    exit(1);
			}
			sequ_write(out_file, in_seq);
		}
	} 
	else {
		seq_file = sequ_new_read_first(&in_seq,
					       seq_file_name,
					       finp_tbl);
		while (in_seq != NULL) {
		    fprintf(stdout, "%s\n", in_seq->id);
		    sequ_seq_free(in_seq);
		    in_seq = sequ_read(seq_file);
		}
	}
	exit(0);
}
