#include <config.h>
#include <print-pima.h>

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

static char	label_size = 0;
int		ff_output = 1;
int		suppress_locus_numbers = 0;


#define BY_PATTERN 0
#define BY_LETTERS 1
#define BY_DIFFERENCES 2


void fix_page_param(void);
void page_headers(FILE *fout, int ofst);

void
do_output()
/*  write output to file or stream  */
{
    char stemp [200],
	*str [128], *seq, *sptr, name_format [30], 
	state;
    char *model_seq = NULL;	/* May be used uninitialized. */
    int longest_seq, indx, indx2, indx3,
	length, itemp, longest_locus_name, page_major, page_minor,
	line_number, this_state;
    int		style = BY_PATTERN;
    FILE *	fout = stdout;

    fix_page_param ();

    longest_locus_name = 0;
    if (label_each_page)
    {	for (indx = 0; indx < num_entries; indx++)
	{   longest_locus_name = (longest_locus_name < 
		(itemp = strlen (entry [indx] -> locus_name)) ?
		itemp : longest_locus_name);
	}
	if (suppress_locus_numbers)
	    sprintf (name_format, "%c-%ds ", '%', 
		longest_locus_name);
	else
	    sprintf (name_format, "%c5d %c-%ds ", '%', '%', 
		longest_locus_name);
	label_size = 5 + 1 + longest_locus_name + 1;
    }
    else
	label_size = 0;

    for (indx = 0; indx < 128; indx++)
	str [indx] = NULL;

    longest_seq = 0;
    for (indx = 0; indx < num_entries; indx++)
        if ((indx2 = entry [indx] -> length) > longest_seq)
	    longest_seq = indx2;
   
    if (str [' '])
	fputs (str [' '], fout);
    fprintf (fout, "\n\n");
    if (!label_each_page)
    {	for (indx = 0; indx < num_entries; indx++)
	{   if (page_length && (!(indx % page_length)) && indx)
	    {   if (ff_output)
		    fputs ("\f", fout);
		fprintf (fout, "\n\n");
	    }
	    fprintf (fout, "%5d %s\n", indx + 1,
		entry [indx] -> locus_name);
	}
	if (ff_output)
	    fputs ("\f", fout);
        fprintf (fout, "\n\n");
    }

    page_major = 0;
    for (indx = 0; indx < longest_seq; indx += bases_per_page)
    {	page_major++; page_minor = 1; line_number = -1;
	for (indx2 = 0; indx2 < num_entries; indx2++)
	{   line_number++;
	    if ((line_number == page_length) || (!indx2))
	    {
		if (indx2)
		{   if (ff_output)
			fputs ("\f", fout);
		    fputs ("\n\n", fout);
		}
		fprintf (fout, "Page %d.%d\n", page_major, page_minor);
		page_headers (fout, indx);
		line_number = 1;
		page_minor++;
	    }
	    if (skip_lines && line_number && 
		!(line_number % skip_lines))
	    {   fprintf (fout, "\n");
		line_number++;
	    }
	    if (label_each_page)
		if (suppress_locus_numbers)
		    fprintf (fout, name_format,
			entry [indx2] -> locus_name);
		else
		    fprintf (fout, name_format, indx2 + 1,
			entry [indx2] -> locus_name);
	    seq = entry [indx2] -> seq;
	    /* hlite = entry [indx2] -> hlite; */
	    length = entry [indx2] -> length;
	    if (str [' '])
		fputs (str [' '], fout);
	    state = ' ';
	    for (indx3 = indx; (indx3 < indx + bases_per_page) &&
		(indx3 < length); indx3++)
	    {   if (bases_per_column && 
		    !((indx3) % bases_per_column) && (indx3 - indx))
		{   if (str [' '])
			fputs (str [' '], fout);
		    putc (' ', fout); 
		    state = ' ';
		}
		if (style == BY_LETTERS)
		{   sptr = str [ (int) seq [indx3]];
		    if (sptr)
			fputs (sptr, fout);
		    else
		    {   if (str [' '])
			    fputs (str [' '], fout);
			putc (seq [indx3], fout);
		    }
		}
		else
		{   if (style == BY_PATTERN)
		      this_state = 0 ; /* hlite [indx3]; */
		    else
		      this_state = (char_set [(int) seq [indx3]] ==
				    char_set [(int) model_seq [indx3]]) ?
			'0' : '1';
		    if (state == this_state)
			putc (seq [indx3], fout);
		    else
		    {   state = this_state;
			if (str [(int) state])
			    fputs (str [(int) state], fout);
			putc (seq [indx3], fout);
		    }
		}
	    }
	    if (str [' '])
		fputs (str [' '], fout);
	    state = ' ';
	    if (output_position && 
		((itemp = count_base (indx2, indx3 - 1)) != -1))
		fprintf (fout, " %6d", itemp);
	    putc ('\n', fout);
        }
	if (indx + bases_per_page < longest_seq) {
	    if (ff_output)
		fputs ("\f", fout);
	    fputs ("\n\n", fout);
	}
    }

    for (indx = 0; indx < 128; indx++) {
	sptr = str [indx];
	if (sptr)
	    free (stemp);
    }

    fclose (fout);
}


/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

void
fix_page_param(void)
/*  twitch the parameters for the pagination of output  */
{   int new_bases_per_page;

    if (bases_per_page < 10)
    {   parm_er ("Bases-per-page %d, less than 10, set to 50",
	    bases_per_page);
	bases_per_page = 50;
    }
    if (bases_per_page > 200)
    {   parm_er ("Bases-per-page %d, greater than 200, set to 50",
	    bases_per_page);
	bases_per_page = 200;
    }
    if (bases_per_column && bases_per_page / bases_per_column < 2)
    {   parm_er (
	    "Bases-per-column %d, less than 2 cols per page, set to 0",
	    bases_per_column);
	bases_per_column = 0;
    }
    if (bases_per_column)
    {   new_bases_per_page = 
	    bases_per_page - (bases_per_page % bases_per_column);
	if (new_bases_per_page != bases_per_page)
	{   parm_er ("Bases-per-page rounded to %d", 
		new_bases_per_page);
	    bases_per_page = new_bases_per_page;
	}
    }
    if (skip_lines < 0)
    {   parm_er ("Skip lines %d, less than 0, set to 0", skip_lines);
	skip_lines = 0;
    }
    if (skip_lines == 1)
	skip_lines = 2;

    if (page_length < 0)
    {   parm_er ("Page length %d, less than 0, set to 0", page_length);
	page_length = 0;
    }
    else if (page_length < 5)
    {   parm_er ("Page length %d, less than 5, set to 5", page_length);
	page_length = 5;
    }
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

void
page_headers (FILE *fout, int ofst)
{   int indx, indx2;

    if (label_each_page)
	for (indx = 0; indx < label_size; indx++)
	    putc (' ', fout);
   
    if (bases_per_column)  /*  there are columns  */
    {   for (indx = 0; indx < bases_per_page; indx +=
	    bases_per_column)
	{   fprintf (fout, "%-6d", ofst + 1 + indx);
	    if (bases_per_column > 12)
	    {   for (indx2 = bases_per_column - 12; indx2; indx2--)
		    putc (' ', fout);
		fprintf (fout, "%6d", ofst + indx +
		    bases_per_column);
	    }
	    else
	    {   for (indx2 = bases_per_column - 6; indx2; indx2--)
		    putc (' ', fout);
	    }
	    putc (' ', fout);
	}
    }
    else  /*  no columns  */ 
    {   fprintf (fout, "%-6d", ofst + 1);
	for (indx2 = bases_per_page - 12; indx2; indx2--)
	    putc (' ', fout);
	fprintf (fout, "%6d", ofst + bases_per_page);
    }
    putc ('\n', fout);
}

/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   
/* ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** */   

void
parm_er (str, ix)
char *str;
int ix;
{
	(void) fprintf(stderr, str, ix);
}
