#include <config.h>
#include <sequ.h>
#include <print-pima.h>

char	*program_name = "print-pima";

int	label_each_page = 1;
int	page_length = 55;
int	bases_per_page = 90;
int	bases_per_column = 15;
int	skip_lines = 5;
int	output_position = 1;

int	num_entries = 0;
seqType **	entry = 0;
char	char_set[128];

/*
 * Prototypes
 */

void	do_output(void);
int	count_base(int start, int stop);
void	parm_er(char * message, int value);
char *	new_string();
char *	string_convert(char * string1, char * string2);

int
main(int argc, char * argv[])
{
    sequ_seq_t	*in_seq;
    sequ_file_t	*in_file;

    int		i;
    seqType **	extraEntry;
    seqType *	nextEntry;

    /* Initialize */
    default_char_set();
    entry = (seqType **) malloc((sizeof(seqType) + sizeof(seqType *))
				* MAX_NUMBER_SEQUENCES);
    if (entry == 0)
    {
	(void) fprintf(stderr, "print-pima: malloc error.\n");
	exit(1);
    }
    extraEntry = entry;
    nextEntry = (seqType *) (entry + MAX_NUMBER_SEQUENCES);
    for (i = 0; i < MAX_NUMBER_SEQUENCES; i++)
    {
	*extraEntry = nextEntry;
	extraEntry++;
	nextEntry++;
    }


    /* Do the arguments. */
    if (argc != 2)
    {
	(void) fprintf(stderr, "print-pima: Bad arguments.\n");
	exit(1);
    }
    if (argv[1][0] == '-' && argv[1][1] == 'h' && argv[1][2] == '\0')
    {
	(void) printf("Usage: print-pima pima-file\n");
	exit(1);
    }

    for (i = 1; i < argc; i++)
    {
	in_file = sequ_new_read_first(&in_seq, argv[i], NULL);

	/* Read sequences. */
	num_entries = 0;

	while (in_seq != NULL)
	{
	    if (num_entries >= MAX_NUMBER_SEQUENCES) {
		fprintf(stderr,
			"print-pima: maximum number of sequences is %d.\n",
			MAX_NUMBER_SEQUENCES);
		exit(1);
	    }
	    entry[num_entries]->locus_name = in_seq->id;
	    entry[num_entries]->seq = in_seq->seq;
	    entry[num_entries]->length = in_seq->length;
	    num_entries++;

	    if (in_seq->title)
		free(in_seq->title);
	    in_seq = sequ_read(in_file);
	}

	/* Print the sequences. */
	do_output();
    }

    exit(0);
}
