#include <config.h>
#include <ctype.h>
#include <print-pima.h>

int
count_base (which, where)
int which, where;
{   char *seq;
    seqType *t;
    int indx, count;

#if 0
    if (which == -1)
	t = consensus_sequence;
    else
#endif
	t = entry [which];
    if (!t)  /*  not an entry  */
	return (-1);
    if (t -> length <= where)
	return (-1);
    seq = t -> seq;
    count = 0;    
    for (indx = 0; (indx <= where) && *seq; indx++, seq++)
	if (isalpha (*seq))
	    count++;
    
    return (count);
}

char *new_string (string)
char *string;
{   char *tmp;

    tmp = (char *) malloc (strlen (string) + 1); /* Why was this 5 before? */
    if (tmp == 0)
    {
	    (void) fprintf(stderr, "new_string: malloc error.\n");
	    exit(1);
    }
    strcpy (tmp, string);
    return (tmp);
}

char *
string_convert (char * old, char * new)
/*  convert the text string ``old'' into ``binary'' string ``new''
    does ``c'' like substitutions:
	\### - substitute octal value
	\n   - new line
	\b   - back space
	\s   - space
	\M   - meta the next character
	\Z   - meta and control the next character
	^    - control the next character
*/
{   unsigned char tmp;

    for (; *old; old++)
    {   switch (*old)
	{   case '\\':
		old++;
		if (!*old)
		{   old [1] = '\0';
		    break;
		}
		switch (*old)
		{   case 'n':
			*old = '\n';
			break;
		    case 'b':
			*old = '\b';
			break;
		    case 's':  /*  to prevent string breaks  */
			*old = ' ';
			break;
		    case 'f':
			*old = '\f';
			break;
		    case 'e':
			*old = '\033';
			break;
		    case 'M':
			old++;
			if (!*old)
			{   *old = 0x80;
			    old [1] = '\0';
			    break;
			}
			*old |= 0x80;
			break;
		    case 'Z':
			old++;
			if (!*old)
			{   *old = 0x80;
			    old [1] = '\0';
			    break;
			}
			*old = (*old | 0x80) & 0x9f;
			break;
		    case '0': case '1': case '2': case '3': case '4':
		    case '5': case '6': case '7': case '8': case '9':
			tmp = *old - '0';
			old++; 
			if (!*old)
			{   *old = tmp;
			    old [1] = '\0';
			    break;
			}
			if ((*old < '0') || (*old > '9'))
			{   old--;
			    *old = tmp;
			    break;
			}
			tmp = tmp * 8 + (*old - '0');
			old++;
			if (!*old)
			{   *old = tmp;
			    old [1] = '\0';
			    break;
			}
			if ((*old < '0') || (*old > '9'))
			{   old--;
			    *old = tmp;
			    break;
			}
			*old = tmp * 8 + (*old - '0');
			break;
		    default:
			break;
		}
		break;
	    case '^':
		old++;
		if (!*old)
		{   *old = '\0';
		    old [1] = '\0';
		    break;
		}
		*old &= 0x9f;
		break;
	    default:
		break;
	}
	*new = *old;
	new++;
    }
    *new = '\0';
    return (new);
}

void
default_char_set(void)
{   int indx;
 
    for (indx = 0; indx < 128; indx++)
        char_set [indx] = indx;
}
