#! /bin/sh

testsdir=$1
test -d "$testsdir" || exit 1

name=${name:-TEST}

command="pima -m class1.mat $options $name $testsdir/sample-family.fa"
echo
echo ">>Running program test: $command"
echo
$command || exit 1
echo
echo ">>Sample run completed."

for clustering in ML SB; do
    for suffix in cluster pattern pima; do
	test=$name-$clustering.$suffix
	sample=SAMPLE-$clustering.$suffix
	cmp=CMP-$clustering.$suffix
	diff=DIFF-$clustering.$suffix.$$
	echo ">>Comparing $test with $sample"
	sed -e "s/^$name-/SAMPLE-/" -e "s/^>$name-/>SAMPLE-/" $test > $cmp
	diff $cmp $testsdir/$sample > $diff
	if test -s $diff; then
	    echo
	    echo "$test and $sample are NOT identical \!\!"
	    if test $suffix = cluster; then
		echo "-- Check for floating point differences"
	    fi
	    echo
	    cat $diff >> all-diffs.$$
	fi
    done
done

if test -s all-diffs.$$; then
    echo
    echo "The file all-diffs.$$ contains a summary of the differences,"
    echo "while the files" DIFF-*.$$
    echo "contain individual differences"
    echo
    exit 1
else
    echo
    echo "*** Your test output is identical to the one provided ***"
    echo
    rm TEST-ML.cluster TEST-ML.pattern TEST-ML.pima \
    TEST-SB.cluster TEST-SB.pattern TEST-SB.pima \
    CMP-* DIFF-*.$$
    exit 0
fi
